(function (isZhCN, isSmartSuggestionEnabled) {
    var AnswerDomain = {};
    AnswerDomain[AnswerDomain.Unknown = 0] = 'Unknown';
    AnswerDomain[AnswerDomain.ChitChat = 1] = 'action://Client/AnswerDomain/Chitchat';
    AnswerDomain[AnswerDomain.Weather = 2] = 'action://Client/AnswerDomain/Weather';
    AnswerDomain[AnswerDomain.Cat3A = 3] = 'action://Client/AnswerDomain/Cat3a';
    AnswerDomain[AnswerDomain.Cat3B = 4] = 'action://Client/AnswerDomain/Cat3b';

    function getAnswerDomain() {
        function getAnswerDomain_zhCN() {
            var domain = AnswerDomain.Unknown;
            var elContent = document.querySelector('#b_content');
            if (elContent) {
                var poleAnswer = elContent.querySelector('#b_pole');
                if (poleAnswer && poleAnswer.querySelector('ul[role]')) {
                    var feedSpan = poleAnswer.querySelector('ul[role]');
                    if (feedSpan.getAttribute('role').toLowerCase() === 'presentation') {
                        domain = AnswerDomain.ChitChat;
                    }
                } else if (elContent.querySelector('.b_cat3a')) {
                    domain = AnswerDomain.Cat3A;
                } else {
                    domain = AnswerDomain.Cat3B;
                }
            }
            return domain;
        }

        function getAnswerDomain_Non_zhCN() {
            var domain = AnswerDomain.Unknown;
            var elContent = document.querySelector('#b_content');
            if (elContent) {
                if (elContent.querySelector('#b_pole')) {
                    if (elContent.querySelector('.wtr_core')) {
                        domain = AnswerDomain.Weather;
                    } else {
                        domain = AnswerDomain.ChitChat;
                    }
                } else if (elContent.querySelector('#b_result .b_cat3a')) {
                    domain = AnswerDomain.Cat3A;
                } else {
                    domain = AnswerDomain.Cat3B;
                }
            }
            return domain;
        }

        return isZhCN === '1' ? getAnswerDomain_zhCN() : getAnswerDomain_Non_zhCN();
    }

    (function () {
        var domain = getAnswerDomain();
        var isCompliance = isZhCN && domain > 3;
        CortanaApp.showWebViewCompliantly(isCompliance, location.href);
    })();

    /**
     * Smart suggestions
     */
    if (isSmartSuggestionEnabled) {
        setTimeout(function () {
            var domain = getAnswerDomain();
            CortanaApp.handleAnswerDomain(AnswerDomain[domain]);
        }, 500);
    }
})(isZhCNParam, isSmartSuggestionEnabledParam);